@use crate::templates::target_cfg_html;
@use rich_crate::RichDep;
@use kitchen_sink::Target;
@use crate::Urler;
@use crate::CratePage;
@use crate::limit_text_len_mid;

@(c: &CratePage<'_>, url: &Urler, set: &[RichDep], label: Option<&str>)

@for d in set.iter() {
    <li property="requirements" class="@if d.dep.optional() && (!d.enabled_by_default || d.display_as_optional) {optional}">
      @if let Some(label) = label {
        <span class="label label-@label">
          @label
        </span>
      }
      @if d.dep.optional() {
        @if d.display_as_optional || d.only_for_features.is_empty() {
          <a href="@url.features(c.ver.origin(), Some(&d.user_alias))" class="feature" title="@if d.enabled_by_default {@d.user_alias enabled by default} else {@d.user_alias is  optional} feature">
            @if d.enabled_by_default {default} else {optional}
          </a>
        } else {
          @for (f, enabled) in &d.only_for_features {
            <a href="@url.features(c.ver.origin(), Some(f))" class="feature" title="@if *enabled {default} else {optional} feature">@limit_text_len_mid(f, 25)@if !*enabled {?}</a>
          }
        }
      }
      @if !d.dep.is_crates_io() {<span class="label label-git">git</span>&nbsp;}<a title="@c.dep_title_attr(d)"
      href="@url.dependency(d)">@d.package</a>@if let Some(updclass)=Some(c.up_to_date_class(d)) {@if updclass != "common" {&nbsp;<span class="version @updclass">@c.pretty_print_req(d.dep.req())</span>}}@for f in d.dep.req_features().iter().take(10) {<a
        href="@url.features(&d.origin(), Some(f))" class="with-feature"><wbr>+<span>@limit_text_len_mid(f, if d.dep.req_features().len() > 2 {15} else {25})</span></a>}@if d.dep.req_features().len() > 10 {…}
      @for t in &d.only_for_targets {
        @if let Target::Cfg(t) = t {
          @:target_cfg_html(t)
        } else {
          <span class="cfg k">@t</span>
        }
      }
    </li>
}
